########################
#  ONI TEAM ARENA 1.2  #
#  Arena of Hurt       #
########################
var int arena_area= 0;
var int arena_players; var int arena_spawn_id;
var int arena_scoring;
var int arena_tag; var int arena_relocate= 1;
################ ARENA STARTUP
func void main(void) {
	chr_teleport 0 0
	ArenaSetupLevel();
######## MISC SETUP
	chr_auto_aim_dist= 0; ui_suppress_prompt= 1;
#	ai2_showlinetochar= 1;
######## ADVANCED SETTINGS
	arena_menu= 0; chr_draw_all_characters= 0;
######## LAUNCH RANDOMIZER
	fork RandInit(); sleep 1;
######## LAUNCH GAME PROCESSES
	ArenaResetFlags(); 
	ArenaResetWeapons(); 
	ArenaResetScore();
	fork ArenaAreaInfo(); 
	fork ArenaMusic();
 	fork ArenaAdvanced(); 
	fork ArenaSetupTeams();
}
func void ArenaTeamsComplete(void) {
	if(arena_tag) arena_relocate= 0;
}
######## RESPAWN LOGIC (CORE)
func void RespawnPlayer(int ai_id, string ai_team, string ai_name, string ai_nick) {
	if(chr_is_player(ai_name)) RandMusic();
	chr_invincible(ai_name, 1); chr_full_health(ai_name);
	fork SendToRandFlag(ai_id, ai_name, ai_team);
	chr_inv_reset(ai_name);
	fork GiveRandWeapon(ai_name);
	fork GiveRandPowerups(ai_name);
	ai2_idle(ai_name); ai2_setjobstate(ai_name);
	ai2_setalert(ai_name, high); ai2_setmovementmode(ai_name, run);
	sleep 30; chr_invincible(ai_name, 0);
	fork ArenaAwareness();

	chr_wait_health(ai_name, 1); if(new_oni eq none) new_oni= ai_name;
	if(arena_scoring) fork Death(ai_team, ai_name, ai_nick);
	if(arena_scoring and ai_name eq arena_bomber_name) {
# KILL THE BOMBER AND RESPAWN HIM WITH THE SAME ID
		chr_set_health(ai_name, 0);
		sleep 200; chr_draw_all_characters= 0;
		ai2_spawn(ai_name, force);
	}
	else {
# FADE PLAYER OTHER PLAYERS
		chr_inv_reset(ai_name); chr_givepowerup(ai_name, invis, -1);
		chr_changeteam(ai_name, Switzerland);
		sleep 60;
	}
	chr_changeteam(ai_name, ai_team);
	fork RespawnPlayer(ai_id, ai_team, ai_name, ai_nick);
}

func void AddPlayer(string ai_team, string ai_name, string ai_nick) {
	dmsg(ai_nick); dmsg("entered the arena");
	ai2_spawn(ai_name); chr_changeteam(ai_name, ai_team);
	ai2_neutralbehavior(ai_name, none)
#	ai2_passive(ai_name, 0); chr_neutral(ai_name, 0);
#	chr_freeze(ai_name, 0); ai2_active(ai_name);
#	chr_lock_active(ai_name);
	ai2_noncombatant(ai_name, 0); chr_unkillable(ai_name, 1);
	if(!arena_tag) fork RespawnPlayer(arena_players, ai_team, ai_name, ai_nick);
	else fork RespawnPlayerTag(arena_players, ai_team, ai_name, ai_nick);
	arena_players= arena_players + 1;
}
#################################### ARENA RESET PC Version
######## KILLS EVERYBODY WITH AN ID GREATER THAN arena_spawn_id
func void ArenaKillPlayerSeq(int player) {
	chr_health(player, 1); player= player + 1; sleep 1;
	if(player < arena_players) fork ArenaKillPlayerSeq(player);
	else chr_pin_character= 0;
#	chr_draw_all_characters= 1;
	
#	chr_health(1, 1); sleep 1;
#	chr_health(2, 1); sleep 1;
#	chr_health(3, 1); sleep 1;
#	chr_health(4, 1); sleep 1;
#	chr_health(5, 1); sleep 1;
#	chr_health(6, 1); sleep 1;
#	chr_health(7, 1); sleep 1;
#	chr_health(8, 1); sleep 1;
#	chr_health(9, 1); sleep 1;
#	chr_health(10, 1); sleep 1;
#	chr_health(11, 1); sleep 1;
#	chr_health(12, 1); sleep 1;
#	chr_health(13, 1); sleep 1;
#	chr_health(14, 1); sleep 1;
#	chr_health(15, 1);
#	chr_pin_character= 0;
#	chr_draw_all_characters= 0; 	
#	chr_health(arena_spawn_id, 1);
#	sleep 1; arena_spawn_id= arena_spawn_id + 1;
#	if(arena_spawn_id < arena_players) fork ArenaKillPlayerSeq();
}



######## ARENA RESET
func void ArenaReset(int next_area) {
	arena_relocate= 1;
	
	if(next_area) {
		dmsg " "
		arena_area= arena_area + 1;
		if(arena_area >= arena_areas) arena_area= 0;
		fork ArenaAreaInfo();
	}
 	fade_out(0, 0, 0, 50); 
	arena_scoring= 0; sleep 50;
	ArenaResetLevel(); 
	ArenaResetWeapons(); 
	ArenaResetFlags(); sleep 1;
#	arena_spawn_id= 0;
#	chr_pin_character= 1;
	ArenaKillAllPlayers(); 
	ai2_allpassive(0);
	sleep 100; fade_in(100);
	ArenaResetScore(); 
#	if(next_area) arena_scoring= 1;
#	if(arena_tag) arena_relocate= 0;
}


